#ifndef _std_lex_h_
#define _std_lex_h_


static char MyStringBuffer[512];

#ifdef __cplusplus
 static int yyinput();
#else
 #define yyinput	input
#endif

void DoIncludeCommand(void)
{
  char c, linebuf[300], *p, *fname = NULL;
  int i, newline, num;
  int ok = 0;

  yyLineNumber++;	/* es wurde ja ein \n gelesen */
  i=0;
  while ((c = yyinput()) != '\n' && c != EOF) {
    linebuf[i++] = c;
  }
  linebuf[i] = '\0';
  /* fprintf(stderr, "found # command (%s)\n", linebuf); */
  newline = atoi(linebuf);
  p = linebuf;
  while (*p && *p != '\"') p++;
  if (*p) {
    p++;
    fname = p;
    while (*p && *p != '\"') p++;
    if (*p) {
      *p = '\0';
      ok = 1;
      p++;
      num = atoi(p);
    }
  }
  if (newline == 0 || !ok) {
    yyerror("Wrong # command");
    yyLineNumber++;
  }
  else {
    yyLineNumber = newline;
    yyFileName = (char *)strdup(fname);
  }
}

void DoCCComment(void)
{
  register char c;
  while ((c = yyinput()) != '\n' && c != EOF);
  yyLineNumber++;
}

void DoCComment(void)
{
  for (;;) {
    register char c;
    while ((c=yyinput()) != '*' && c != EOF) {
      if (c == '\n') yyLineNumber++;
    }
    if (c == '*') {
      while ((c=yyinput()) == '*');
      if (c == '/') break;
      if (c == EOF) {
        yyerror("EOF in comment");
        break;
      }
    }
  }
}


/* Die Funktion liest einen gequoteten String und Speichert ihn ohne '"'  */
char *ReadQuotedString(void)
{
  char EscChar = 0;
  char current = yyinput();
  int counter = 0;
  int end = 0;
  while (!end) {
    end = (current == '"') && !EscChar;
    if (!end) {
      if (current == EOF) {
        yyerror("EOF in string");
        return NULL;
      }
      if (current == '\n') {
        yyerror("unterminated String");
        yyLineNumber++;
        return NULL;
      }
      MyStringBuffer[counter++] = current;
      EscChar = current == '\\' && !EscChar;
      current = yyinput();
    }
  }
  MyStringBuffer[counter] = '\0';
  return MyStringBuffer;
}

void yyerror(char * msg)
{
  static int notfirst = 0;
  char buf[512];

  if (notfirst) {
    notfirst = 1;
    fprintf(yyout, "\n");
  }

  if (yyFileName != NULL) {
    sprintf(buf, "%s:%d: %s ",
            yyFileName, yyLineNumber, msg);
  }
  else {
    sprintf(buf, "???:%d: %s ", yyLineNumber, msg);
  }
  if (strlen(yytext)>15) {
    yytext[15] = '\0';
    strcat(yytext, "...");
  }
  if (yyeof) strcat(buf, "at end of input");
  else if (*yytext=='\0') strcat(buf, "at null character");
  else if (*yytext=='"') strcat(buf, "before string constant");
  else if (*yytext < 040 || *yytext >= 0177)
        sprintf(buf+strlen(buf), "before character 0%o", *yytext);
  else sprintf(buf+strlen(buf), "before `%s'", yytext);

  fprintf(yyout, "%s\n", buf);
}


void unputToken(void)
{
  int i;
  char * yycopy = strdup(yytext);
  void yyunput();

  for (i=yyleng-1; i>=0; --i) {
    yyunput(yycopy[i], yytext_ptr);
  }
  free(yycopy);
}

#endif
